#!/bin/bash

if [ -e /etc/redhat-release ] ; then

	echo "local all       all             ident syslogfeeder
local   syslog all  trust
host all all 202.83.64.128 255.255.255.128 md5
host all all 127.0.0.1 255.255.255.255 md5" >> /var/lib/pgsql/data/pg_hba.conf
echo "syslogfeeder  root              syslogfeeder" >> /var/lib/pgsql/data/pg_ident.conf

elif [ -e /etc/debian_version ] ; then

echo "local all       all             ident syslogfeeder
local   syslog all  trust
host all all 202.83.64.128 255.255.255.128 md5
host all all 127.0.0.1 255.255.255.255 md5" >> /etc/postgresql/7.4/main/pg_hba.conf
echo "syslogfeeder  root              syslogfeeder" >> /etc/postgresql/7.4/main/pg_ident.conf
else
echo "Error, distribution unknown. Please manually configure your database and import the db scripts."
exit 1 
fi

# Reload pgsql conf
killall -SIGHUP postmaster

cp *pgsql*sql /tmp

su postgres -c "psql template1 < /tmp/dbsetup-pgsql-db.sql"
su postgres -c "psql syslog < /tmp/dbsetup-pgsql-tables.sql"
su postgres -c "psql syslog <  /tmp/dbsetup-pgsql-permissions.sql"

rm -f /tmp/*pgsql*sql
